(* File MicroC/MicroCC.fs *)

module MicroCC

let args = System.Environment.GetCommandLineArgs();;

let _ = printf "ITU micro-C backwards compiler version 0.0.0.2 of 2010-01-07\n";;

let _ = 
   if args.Length > 1 then
      let source = args.[1]
      let stem = if source.EndsWith(".c") then source.Substring(0,source.Length-2) 
                 else source
      let target = stem + ".out"
      in printf "Compiling %s to %s\n" source target;
         try ignore (Contcomp.contCompileToFile (Parse.fromFile source) target)
         with Failure msg -> printf "ERROR: %s\n" msg
   else
      printf "Usage: microcc <source file>\n";;
